﻿<%@ Page Language="C#" AutoEventWireup="true" %>

<script runat="server">

    private string savePath = "~/Upload";

    protected void Page_Load(object sender, EventArgs e)
    {
        string fileName = Request.QueryString["FileName"];
        string fileComment = Request.QueryString["Comment"];
        string tag = Request.QueryString["Tag"];
        fileName = HttpUtility.UrlDecode(fileName).Replace("..\\", "");
        bool complete = string.IsNullOrEmpty(Request.QueryString["Complete"]) ? true : bool.Parse(Request.QueryString["Complete"]);
        bool querySize = string.IsNullOrEmpty(Request.QueryString["QuerySize"]) ? false : bool.Parse(Request.QueryString["QuerySize"]);
        long startByte = string.IsNullOrEmpty(Request.QueryString["StartByte"]) ? 0 : long.Parse(Request.QueryString["StartByte"]); ;

        if (string.IsNullOrEmpty(fileName) || string.IsNullOrEmpty(savePath)) return;

        string dirPath = savePath;
        string filePath;

        if (savePath.StartsWith("/") || savePath.StartsWith("~"))
        {
            try
            {
                dirPath = Server.MapPath(savePath);
            }
            catch { }
        }

        filePath = System.IO.Path.Combine(dirPath, fileName);

        if (querySize)
        {
            if (!System.IO.Directory.Exists(dirPath))
            {
                Response.Write("The path for file storage not found on the server.");
                Response.Flush();
                return;
            }

            System.IO.FileInfo fi = new System.IO.FileInfo(filePath);
            if (!fi.Exists) Response.Write("0");
            else Response.Write(fi.Length.ToString());
            Response.Flush();
        }
        else
        {
            try
            {
                if (startByte > 0 && System.IO.File.Exists(filePath))
                {
                    using (System.IO.FileStream fs = System.IO.File.Open(filePath, System.IO.FileMode.Append))
                    {
                        SaveFile(Request.InputStream, fs);
                        Response.Write(string.Format("Write chunk since byte {0}", startByte));
                    }
                }
                else
                {
                    using (System.IO.FileStream fs = System.IO.File.Create(filePath))
                    {
                        SaveFile(Request.InputStream, fs);
                        Response.Write("Creating file...");
                    }
                }
                if (complete)
                {
                    Response.Clear();
                    Response.Write("File uploaded.");
                    // Place here the code making postprocessing of the uploaded file (moving to other location, database, etc). 
                }

                Response.Flush();
            }
            catch (Exception)
            {
                Response.Clear();
                Response.Write("Write error.");
                Response.Flush();
            }
        }
    }

    private void SaveFile(System.IO.Stream stream, System.IO.FileStream fs)
    {
        byte[] buffer = new byte[4096];
        int bytesRead;
        while ((bytesRead = stream.Read(buffer, 0, buffer.Length)) != 0)
        {
            fs.Write(buffer, 0, bytesRead);
        }
    }
</script>

